// ============================================================================
// BDreaderGAMEBDreadLevelMagic64.cpp
// ----------------------------------------------------------------------------
// (c) 2022-2024 by HerzAusGold
//               Hubert Haberkorn
//               herz-aus-gold-42@gmx.de
//               http://www.arthurdent.de/
// ----------------------------------------------------------------------------
// The above copyright notice and this permission notice 
// shall be included in all copies or substantial portions 
// of the Software.
// ----------------------------------------------------------------------------
// read file dump from "BoulderDsh" (by Guido Mersmann) 
// and extract level data to -> ".gamebd" file
// generate "levelinfo.conf" with some extra info
// ============================================================================

#include "stdio.h"

#include <string>
#include <iostream>
#include <vector>
#include <filesystem>

#include "BDreaderGAMEBDmain.h"
#include "BDreaderGAMEBDutil.h"

using namespace std;

char convert (byte_t ch)
{
    char elem = '-';
    switch(ch) {
        case 0x00 : elem = ' '; break;  // empty
        case 0x14 : elem = '*'; break;  // diamond
        case 0x10 : elem = 'o'; break;  // rock
        case 0x01 : elem = '.'; break;  // dirt
        case 0x07 : elem = '#'; break;  // steelwall
        case 0x02 : elem = 'W'; break;  // wall
        case 0x08 : elem = 'F'; break;  // firefly down
        case 0x09 : elem = 'B'; break;  // butterfly up

        case 0x25 : elem = 'p'; break;  // player in (base)
        case 0x26 : elem = 'p'; break;  // player in (get ready)
        case 0x27 : elem = 'p'; break;  // player in (ready)
        case 0x28 : elem = 'p'; break;  // player in (ready now)
        case 0x38 : elem = 'P'; break;  // player in (player)

        case 0x04 : elem = '!'; break;  // visible out
        default   : elem = '-'; break;
    }
    return elem;
}


/*---- readLevelMagic64 -----------------------------------------------------------*/
int readLevelMagic64(string filename, 
                     string offsetStr, 
                     int i_levelNo,
                     int i_doFileWrite)
{
    byte_t buffer[2]   = {0};
    byte_t cave[22*40] = {0};

    int fok = 0;
    FILE *fp = fopen(filename.c_str(), "rb");
    if (fp != NULL) {
        int maxy = 22;
        int maxx = 40;
        int maxcavelen = maxx*maxy;
        int cavelen = 0;
        while (!feof(fp)) {
            fok = fread(buffer, 1, 1, fp);
            if (fok > 0) {
                cave[cavelen] = buffer[0];
                cavelen++;
                if (cavelen >= maxcavelen) {
                    break;
                }
            } else {
                break;
            }
        }
        fclose(fp);

        cout << string(80, '-') << endl;
        cout << "0         1         2         3         4         5" << endl;
        cout << "012345678901234567890123456789012345678901234567890" << endl;
        cout << string(80, '-') << endl;
        // output
        int pos = 0;
        for (int yy=0; yy < maxy; yy++) {
            for (int xx=0; xx < maxx; xx++) {
                char elem = convert(cave[pos]);
                printf("%c", elem);
                pos++;
            }
            printf("\n");
        }
        cout << string(80, '-') << endl;
    }
    return 1;
}
